/*
 * kernel/power/suspend2.h
 *
 * Copyright (C) 2004-2006 Nigel Cunningham <nigel@suspend2.net>
 *
 * This file is released under the GPLv2.
 *
 * It contains declarations used throughout swsusp and suspend2.
 *
 */
#ifndef KERNEL_POWER_SUSPEND_CORE_H
#define KERNEL_POWER_SUSPEND_CORE_H

#include <linux/delay.h>
#include <linux/bootmem.h>

extern unsigned long suspend_orig_mem_free;

#define KB(x) ((x) << (PAGE_SHIFT - 10))
#define MB(x) ((x) >> (20 - PAGE_SHIFT))

extern int suspend_start_anything(int starting_cycle);
extern void suspend_finish_anything(int finishing_cycle);

#if 1
#define PRINTK(a...) do { } while(0)
#else
#define PRINTK(fmt, arg...) printk(KERN_DEBUG fmt, ##arg)
#endif

#endif
